searchData={"items":[{"type":"module","title":"OpenaiEx","doc":"`OpenaiEx` is an Elixir library that provides a community-maintained client for the OpenAI API.\n\nThe library closely follows the structure of the [official OpenAI API client libraries](https://platform.openai.com/docs/api-reference)\nfor [Python](https://github.com/openai/openai-python)\nand [JavaScript](https://github.com/openai/openai-node),\nmaking it easy to understand and reuse existing documentation and code.","ref":"OpenaiEx.html"},{"type":"function","title":"OpenaiEx.new/2","doc":"Creates a new OpenaiEx struct with the specified token and organization.\n\nSee https://platform.openai.com/docs/api-reference/authentication for details.","ref":"OpenaiEx.html#new/2"},{"type":"function","title":"OpenaiEx.new_file/1","doc":"Create file parameter struct for use in multipart requests.\n\nOpenAI API has endpoints which need a file parameter, such as Files and Audio.\nThis function creates a file parameter given a name (optional) and content or a local file path.","ref":"OpenaiEx.html#new_file/1"},{"type":"module","title":"OpenaiEx.Audio","doc":"This module provides an implementation of the OpenAI audio API. The API reference can be found at https://platform.openai.com/docs/api-reference/audio.","ref":"OpenaiEx.Audio.html"},{"type":"module","title":"API Fields - OpenaiEx.Audio","doc":"The following fields can be used as parameters when creating a new audio request:\n\n- `:file`\n- `:model`\n- `:prompt`\n- `:response_format`\n- `:temperature`\n- `:language`","ref":"OpenaiEx.Audio.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Audio.new/1","doc":"Creates a new audio request with the given arguments.","ref":"OpenaiEx.Audio.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Audio.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the audio request.","ref":"OpenaiEx.Audio.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Audio.new/1","doc":"A map containing the fields of the audio request.\n\nThe `:file` and `:model` fields are required.","ref":"OpenaiEx.Audio.html#new/1-returns"},{"type":"function","title":"OpenaiEx.Audio.transcribe/2","doc":"Calls the audio transcription endpoint.","ref":"OpenaiEx.Audio.html#transcribe/2"},{"type":"function","title":"Arguments - OpenaiEx.Audio.transcribe/2","doc":"- `openai`: A map containing the OpenAI configuration.\n- `audio`: A map containing the audio request.","ref":"OpenaiEx.Audio.html#transcribe/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Audio.transcribe/2","doc":"A map containing the audio response.\n\nSee https://platform.openai.com/docs/api-reference/audio/create for more information.","ref":"OpenaiEx.Audio.html#transcribe/2-returns"},{"type":"function","title":"OpenaiEx.Audio.translate/2","doc":"Calls the audio translation endpoint.","ref":"OpenaiEx.Audio.html#translate/2"},{"type":"function","title":"Arguments - OpenaiEx.Audio.translate/2","doc":"- `openai`: A map containing the OpenAI configuration.\n- `audio`: A map containing the audio request.","ref":"OpenaiEx.Audio.html#translate/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Audio.translate/2","doc":"A map containing the audio response.\n\nSee https://platform.openai.com/docs/api-reference/audio/create for more information.","ref":"OpenaiEx.Audio.html#translate/2-returns"},{"type":"module","title":"OpenaiEx.ChatCompletion","doc":"This module provides an implementation of the OpenAI chat completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/chat/completions.","ref":"OpenaiEx.ChatCompletion.html"},{"type":"module","title":"API Fields - OpenaiEx.ChatCompletion","doc":"The following fields can be used as parameters when creating a new chat completion:\n\n- `:model`\n- `:messages`\n- `:temperature`\n- `:top_p`\n- `:n`\n- `:stop`\n- `:max_tokens`\n- `:presence_penalty`\n- `:frequency_penalty`\n- `:logit_bias`\n- `:user`","ref":"OpenaiEx.ChatCompletion.html#module-api-fields"},{"type":"function","title":"OpenaiEx.ChatCompletion.create/2","doc":"","ref":"OpenaiEx.ChatCompletion.html#create/2"},{"type":"function","title":"OpenaiEx.ChatCompletion.create/3","doc":"Calls the chat completion 'create' endpoint.","ref":"OpenaiEx.ChatCompletion.html#create/3"},{"type":"function","title":"Arguments - OpenaiEx.ChatCompletion.create/3","doc":"- `openai`: The OpenAI configuration.\n- `chat_completion`: The chat completion request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.ChatCompletion.html#create/3-arguments"},{"type":"function","title":"Returns - OpenaiEx.ChatCompletion.create/3","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/chat/completions/create for more information.","ref":"OpenaiEx.ChatCompletion.html#create/3-returns"},{"type":"function","title":"OpenaiEx.ChatCompletion.new/1","doc":"Creates a new chat completion request with the given arguments.","ref":"OpenaiEx.ChatCompletion.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.ChatCompletion.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the chat completion request.","ref":"OpenaiEx.ChatCompletion.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.ChatCompletion.new/1","doc":"A map containing the fields of the chat completion request.\n\nThe `:model` and `:messages` fields are required. The `:messages` field should be a list of maps with the `OpenaiEx.ChatMessage` structure.\n\nExample usage:\n\n    iex> _request = OpenaiEx.ChatCompletion.new(model: \"davinci\", messages: [OpenaiEx.ChatMessage.user(\"Hello, world!\")])\n    %{messages: [%{content: \"Hello, world!\", role: \"user\"}], model: \"davinci\"}\n\n    iex> _request = OpenaiEx.ChatCompletion.new(%{model: \"davinci\", messages: [OpenaiEx.ChatMessage.user(\"Hello, world!\")]})\n    %{messages: [%{content: \"Hello, world!\", role: \"user\"}], model: \"davinci\"}","ref":"OpenaiEx.ChatCompletion.html#new/1-returns"},{"type":"module","title":"OpenaiEx.ChatMessage","doc":"This module provides an implementation of the OpenAI chat message API. Information about these messages can be found at   https://platform.openai.com/docs/guides/chat/introduction.","ref":"OpenaiEx.ChatMessage.html"},{"type":"module","title":"API Fields - OpenaiEx.ChatMessage","doc":"The following fields can be used as parameters when creating a new chat message:\n\n- `:content`\n- `:role`","ref":"OpenaiEx.ChatMessage.html#module-api-fields"},{"type":"function","title":"OpenaiEx.ChatMessage.assistant/1","doc":"Create a `ChatMessage` map with role `assistant`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.assistant(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"assistant\"}","ref":"OpenaiEx.ChatMessage.html#assistant/1"},{"type":"function","title":"OpenaiEx.ChatMessage.system/1","doc":"Create a `ChatMessage` map with role `system`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.system(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"system\"}","ref":"OpenaiEx.ChatMessage.html#system/1"},{"type":"function","title":"OpenaiEx.ChatMessage.user/1","doc":"Create a `ChatMessage` map with role `user`.\n\nExample usage:\n\n    iex> _message = OpenaiEx.ChatMessage.user(\"Hello, world!\")\n    %{content: \"Hello, world!\", role: \"user\"}","ref":"OpenaiEx.ChatMessage.html#user/1"},{"type":"module","title":"OpenaiEx.Completion","doc":"This module provides an implementation of the OpenAI completions API. The API reference can be found at https://platform.openai.com/docs/api-reference/completions.","ref":"OpenaiEx.Completion.html"},{"type":"module","title":"API Fields - OpenaiEx.Completion","doc":"The following fields can be used as parameters when creating a new completion:\n\n- `:model`\n- `:prompt`\n- `:suffix`\n- `:max_tokens`\n- `:temperature`\n- `:top_p`\n- `:n`\n- `:logprobs`\n- `:echo`\n- `:stop`\n- `:presence_penalty`\n- `:frequency_penalty`\n- `:best_of`\n- `:logit_bias`\n- `:user`","ref":"OpenaiEx.Completion.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Completion.create/2","doc":"","ref":"OpenaiEx.Completion.html#create/2"},{"type":"function","title":"OpenaiEx.Completion.create/3","doc":"Calls the completion 'create' endpoint.","ref":"OpenaiEx.Completion.html#create/3"},{"type":"function","title":"Arguments - OpenaiEx.Completion.create/3","doc":"- `openai`: The OpenAI configuration.\n- `completion`: The completion request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.Completion.html#create/3-arguments"},{"type":"function","title":"Returns - OpenaiEx.Completion.create/3","doc":"A map containing the API response.\n\nSee https://platform.openai.com/docs/api-reference/completions/create for more information.","ref":"OpenaiEx.Completion.html#create/3-returns"},{"type":"function","title":"OpenaiEx.Completion.new/1","doc":"Creates a new completion request with the given arguments.","ref":"OpenaiEx.Completion.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Completion.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the completion request.","ref":"OpenaiEx.Completion.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Completion.new/1","doc":"A map containing the fields of the completion request.\n\nThe `:model` field is required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Completion.new(model: \"davinci\")\n    %{model: \"davinci\"}\n\n    iex> _request = OpenaiEx.Completion.new(%{model: \"davinci\"})\n    %{model: \"davinci\"}","ref":"OpenaiEx.Completion.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Edit","doc":"This module provides an implementation of the OpenAI edits API. The API reference can be found at https://platform.openai.com/docs/api-reference/edits.","ref":"OpenaiEx.Edit.html"},{"type":"module","title":"API Fields - OpenaiEx.Edit","doc":"The following fields can be used as parameters when creating a new edit:\n- `:model`\n- `:input`\n- `:instruction`\n- `:n`\n- `:temperature`\n- `:top_p`","ref":"OpenaiEx.Edit.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Edit.create/2","doc":"Calls the edit endpoint.","ref":"OpenaiEx.Edit.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Edit.create/2","doc":"- `openai`: The OpenAI configuration.\n- `edit`: The edit request, as a map with keys corresponding to the API fields.","ref":"OpenaiEx.Edit.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Edit.create/2","doc":"A map containing the fields of the edit response.\n\nSee https://platform.openai.com/docs/api-reference/edits/create for more information.","ref":"OpenaiEx.Edit.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Edit.new/1","doc":"Creates a new edit request with the given arguments.","ref":"OpenaiEx.Edit.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Edit.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the edit request.","ref":"OpenaiEx.Edit.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Edit.new/1","doc":"A map containing the fields of the edit request.\n\nThe `:model` and `:instruction` fields are required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Edit.new(model: \"davinci\", instruction: \"This is a test\")\n    %{instruction: \"This is a test\", model: \"davinci\"}\n\n    iex> _request = OpenaiEx.Edit.new(%{model: \"davinci\", instruction: \"This is a test\"})\n    %{instruction: \"This is a test\", model: \"davinci\"}","ref":"OpenaiEx.Edit.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Embedding","doc":"This module provides an implementation of the OpenAI embeddings API. The API reference can be found at https://platform.openai.com/docs/api-reference/embeddings.","ref":"OpenaiEx.Embedding.html"},{"type":"module","title":"API Fields - OpenaiEx.Embedding","doc":"The following fields can be used as parameters when creating a new embedding:\n\n- `:model`\n- `:input`\n- `:user`","ref":"OpenaiEx.Embedding.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Embedding.create/2","doc":"Calls the embedding endpoint.","ref":"OpenaiEx.Embedding.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Embedding.create/2","doc":"- `openai`: The OpenAI configuration to use.\n- `embedding`: The embedding request to send.","ref":"OpenaiEx.Embedding.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Embedding.create/2","doc":"A map containing the fields of the embedding response.\n\nSee https://platform.openai.com/docs/api-reference/embeddings/create for more information.","ref":"OpenaiEx.Embedding.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Embedding.new/1","doc":"Creates a new embedding request with the given arguments.","ref":"OpenaiEx.Embedding.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Embedding.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the embedding request.","ref":"OpenaiEx.Embedding.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Embedding.new/1","doc":"A map containing the fields of the embedding request.\n\nThe `:model` and `:input` fields are required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Embedding.new(model: \"davinci\", input: \"This is a test\")\n    %{input: \"This is a test\", model: \"davinci\"}\n\n    iex> _request = OpenaiEx.Embedding.new(%{model: \"davinci\", input: \"This is a test\"})\n    %{input: \"This is a test\", model: \"davinci\"}","ref":"OpenaiEx.Embedding.html#new/1-returns"},{"type":"module","title":"OpenaiEx.File","doc":"This module provides an implementation of the OpenAI files API. The API reference can be found at https://platform.openai.com/docs/api-reference/files.","ref":"OpenaiEx.File.html"},{"type":"module","title":"API Fields - OpenaiEx.File","doc":"The following fields can be used as parameters for various endpoints of the API:\n\n- `:file`\n- `:purpose`\n- `:file_id`","ref":"OpenaiEx.File.html#module-api-fields"},{"type":"function","title":"OpenaiEx.File.create/2","doc":"Calls the file upload endpoint.","ref":"OpenaiEx.File.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.File.create/2","doc":"- `openai`: The OpenAI configuration.\n- `upload`: A map containing the fields of the file upload request.","ref":"OpenaiEx.File.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.create/2","doc":"A map containing the fields of the file upload response.\n\nhttps://platform.openai.com/docs/api-reference/files/upload","ref":"OpenaiEx.File.html#create/2-returns"},{"type":"function","title":"OpenaiEx.File.delete/2","doc":"Calls the file delete endpoint.","ref":"OpenaiEx.File.html#delete/2"},{"type":"function","title":"Arguments - OpenaiEx.File.delete/2","doc":"- `openai`: The OpenAI configuration.\n- `file_id`: The ID of the file to delete.","ref":"OpenaiEx.File.html#delete/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.delete/2","doc":"A map containing the fields of the file delete response.\n\nhttps://platform.openai.com/docs/api-reference/files/delete","ref":"OpenaiEx.File.html#delete/2-returns"},{"type":"function","title":"OpenaiEx.File.download/2","doc":"Calls the file retrieve_content endpoint.","ref":"OpenaiEx.File.html#download/2"},{"type":"function","title":"Arguments - OpenaiEx.File.download/2","doc":"- `openai`: The OpenAI configuration.\n- `file_id`: The ID of the file to retrieve the content of.","ref":"OpenaiEx.File.html#download/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.download/2","doc":"A map containing the fields of the file retrieve_content response.\n\nhttps://platform.openai.com/docs/api-reference/files/retrieve-content","ref":"OpenaiEx.File.html#download/2-returns"},{"type":"function","title":"OpenaiEx.File.list/1","doc":"Lists the files that belong to the user's organization.\n\nhttps://platform.openai.com/docs/api-reference/files/list","ref":"OpenaiEx.File.html#list/1"},{"type":"function","title":"OpenaiEx.File.new/1","doc":"Creates a new file retrieve / deletion / retrieve_content request with the given arguments.","ref":"OpenaiEx.File.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.File.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the file retrieve / deletion / retrieve_content request.","ref":"OpenaiEx.File.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.new/1","doc":"A map containing the fields of the file retrieve / deletion / retrieve_content request.\n\nThe `:file_id` field is required.","ref":"OpenaiEx.File.html#new/1-returns"},{"type":"function","title":"OpenaiEx.File.new_upload/1","doc":"Creates a new file upload request with the given arguments.","ref":"OpenaiEx.File.html#new_upload/1"},{"type":"function","title":"Arguments - OpenaiEx.File.new_upload/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the file upload request.","ref":"OpenaiEx.File.html#new_upload/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.new_upload/1","doc":"A map containing the fields of the file upload request.\n\nThe `:file` and `:purpose` fields are required.","ref":"OpenaiEx.File.html#new_upload/1-returns"},{"type":"function","title":"OpenaiEx.File.retrieve/2","doc":"Calls the file retrieve endpoint.","ref":"OpenaiEx.File.html#retrieve/2"},{"type":"function","title":"Arguments - OpenaiEx.File.retrieve/2","doc":"- `openai`: The OpenAI configuration.\n- `file_id`: The ID of the file to retrieve.","ref":"OpenaiEx.File.html#retrieve/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.File.retrieve/2","doc":"A map containing the fields of the file retrieve response.\n\nhttps://platform.openai.com/docs/api-reference/files/retrieve","ref":"OpenaiEx.File.html#retrieve/2-returns"},{"type":"module","title":"OpenaiEx.FineTune","doc":"This module provides an implementation of the OpenAI fine-tune API. The API reference can be found at https://platform.openai.com/docs/api-reference/fine-tunes.","ref":"OpenaiEx.FineTune.html"},{"type":"module","title":"API Fields - OpenaiEx.FineTune","doc":"The following fields can be used as parameters for various endpoints of the API:\n\n- `:training_file`\n- `:validation_file`\n- `:model`\n- `:n_epochs`\n- `:batch_size`\n- `:learning_rate_multiplier`\n- `:prompt_loss_weight`\n- `:compute_classification_metrics`\n- `:classification_n_classes`\n- `:classification_positive_class`\n- `:classification_betas`\n- `:suffix`\n- `:stream`","ref":"OpenaiEx.FineTune.html#module-api-fields"},{"type":"function","title":"OpenaiEx.FineTune.cancel/2","doc":"Calls the fine-tune cancel endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/cancel","ref":"OpenaiEx.FineTune.html#cancel/2"},{"type":"function","title":"OpenaiEx.FineTune.create/2","doc":"Calls the fine-tune creation endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/create","ref":"OpenaiEx.FineTune.html#create/2"},{"type":"function","title":"OpenaiEx.FineTune.list/1","doc":"Calls the fine-tune list endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/list","ref":"OpenaiEx.FineTune.html#list/1"},{"type":"function","title":"OpenaiEx.FineTune.list_events/2","doc":"Calls the fine-tune list events endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/events","ref":"OpenaiEx.FineTune.html#list_events/2"},{"type":"function","title":"OpenaiEx.FineTune.new/1","doc":"Creates a new fine-tune request with the given arguments.","ref":"OpenaiEx.FineTune.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.FineTune.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the fine-tune request.","ref":"OpenaiEx.FineTune.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.FineTune.new/1","doc":"A map containing the fields of the fine-tune request.","ref":"OpenaiEx.FineTune.html#new/1-returns"},{"type":"function","title":"OpenaiEx.FineTune.retrieve/2","doc":"Calls the fine-tune retrieve endpoint.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/retrieve","ref":"OpenaiEx.FineTune.html#retrieve/2"},{"type":"module","title":"OpenaiEx.Image","doc":"This module provides an implementation of the OpenAI images API. The API reference can be found at https://platform.openai.com/docs/api-reference/images.","ref":"OpenaiEx.Image.html"},{"type":"module","title":"API Fields - OpenaiEx.Image","doc":"The following fields can be used as parameters when creating a new image:\n\n- `:prompt`\n- `:n`\n- `:size`\n- `:response_format`\n- `:user`","ref":"OpenaiEx.Image.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Image.create/2","doc":"Calls the image generation endpoint.","ref":"OpenaiEx.Image.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Image.create/2","doc":"- `openai`: The OpenAI configuration to use.\n- `image`: The image request to send.","ref":"OpenaiEx.Image.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.create/2","doc":"A map containing the response from the OpenAI API.\n\nSee the [OpenAI API Create Image reference](https://platform.openai.com/docs/api-reference/images/create) for more information.","ref":"OpenaiEx.Image.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Image.create_edit/2","doc":"Calls the image edit endpoint.","ref":"OpenaiEx.Image.html#create_edit/2"},{"type":"function","title":"Arguments - OpenaiEx.Image.create_edit/2","doc":"- `openai`: The OpenAI configuration to use.\n- `image_edit`: The image edit request to send.","ref":"OpenaiEx.Image.html#create_edit/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.create_edit/2","doc":"A map containing the response from the OpenAI API.\n\nSee the [OpenAI API Create Image Edit reference](https://platform.openai.com/docs/api-reference/images/create-edit) for more information.","ref":"OpenaiEx.Image.html#create_edit/2-returns"},{"type":"function","title":"OpenaiEx.Image.create_variation/2","doc":"Calls the image variation endpoint.","ref":"OpenaiEx.Image.html#create_variation/2"},{"type":"function","title":"Arguments - OpenaiEx.Image.create_variation/2","doc":"- `openai`: The OpenAI configuration to use.\n- `image_variation`: The image variation request to send.","ref":"OpenaiEx.Image.html#create_variation/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.create_variation/2","doc":"A map containing the response from the OpenAI API.\n\nSee the [OpenAI API Create Image Variation reference](https://platform.openai.com/docs/api-reference/images/create-variation) for more information.","ref":"OpenaiEx.Image.html#create_variation/2-returns"},{"type":"function","title":"OpenaiEx.Image.new/1","doc":"Creates a new image request with the given arguments.","ref":"OpenaiEx.Image.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Image.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the image request.","ref":"OpenaiEx.Image.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.new/1","doc":"A map containing the fields of the image request.\n\nThe `:prompt` field is required.\n\nExample usage:\n\n    iex> _request = OpenaiEx.Image.new(prompt: \"This is a test\")\n    %{prompt: \"This is a test\"}\n\n    iex> _request = OpenaiEx.Image.new(%{prompt: \"This is a test\"})\n    %{prompt: \"This is a test\"}","ref":"OpenaiEx.Image.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Image.Edit","doc":"This module provides constructors for OpenAI Image Edit API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-edit.","ref":"OpenaiEx.Image.Edit.html"},{"type":"module","title":"API Fields - OpenaiEx.Image.Edit","doc":"- `:image`\n- `:mask`\n- `:prompt`\n- `:n`\n- `:size`\n- `:response_format`\n- `:user`","ref":"OpenaiEx.Image.Edit.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Image.Edit.new/1","doc":"Creates a new image edit request with the given arguments.","ref":"OpenaiEx.Image.Edit.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Image.Edit.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the image edit request.","ref":"OpenaiEx.Image.Edit.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.Edit.new/1","doc":"A map containing the fields of the image edit request.\n\nThe `:image` and `:prompt` fields are required.","ref":"OpenaiEx.Image.Edit.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Image.Variation","doc":"This module provides constructors for OpenAI Image Variation API request structure. The API reference can be found at https://platform.openai.com/docs/api-reference/images/create-variation.","ref":"OpenaiEx.Image.Variation.html"},{"type":"module","title":"API Fields - OpenaiEx.Image.Variation","doc":"- `:image`\n- `:n`\n- `:size`\n- `:response_format`\n- `:user`","ref":"OpenaiEx.Image.Variation.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Image.Variation.new/1","doc":"Creates a new image variation request with the given arguments.","ref":"OpenaiEx.Image.Variation.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Image.Variation.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the image variation request.","ref":"OpenaiEx.Image.Variation.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Image.Variation.new/1","doc":"A map containing the fields of the image variation request.\n\nThe `:image` field is required.","ref":"OpenaiEx.Image.Variation.html#new/1-returns"},{"type":"module","title":"OpenaiEx.Model","doc":"This module provides an implementation of the OpenAI Models API. Information about these models can be found at https://platform.openai.com/docs/models.","ref":"OpenaiEx.Model.html"},{"type":"function","title":"OpenaiEx.Model.delete/2","doc":"Deletes a specific model.\n\nhttps://platform.openai.com/docs/api-reference/fine-tunes/delete-model","ref":"OpenaiEx.Model.html#delete/2"},{"type":"function","title":"OpenaiEx.Model.list/1","doc":"Lists the available models.\n\nhttps://platform.openai.com/docs/api-reference/models/list","ref":"OpenaiEx.Model.html#list/1"},{"type":"function","title":"OpenaiEx.Model.retrieve/2","doc":"Retrieves a specific model.\n\nhttps://platform.openai.com/docs/api-reference/models/retrieve","ref":"OpenaiEx.Model.html#retrieve/2"},{"type":"module","title":"OpenaiEx.Moderation","doc":"This module provides an implementation of the OpenAI moderation API. The API reference can be found at https://platform.openai.com/docs/api-reference/moderations.","ref":"OpenaiEx.Moderation.html"},{"type":"module","title":"API Fields - OpenaiEx.Moderation","doc":"The following fields can be used as parameters when creating a new moderation:\n\n- `:input`\n- `:model`","ref":"OpenaiEx.Moderation.html#module-api-fields"},{"type":"function","title":"OpenaiEx.Moderation.create/2","doc":"Calls the moderation endpoint.","ref":"OpenaiEx.Moderation.html#create/2"},{"type":"function","title":"Arguments - OpenaiEx.Moderation.create/2","doc":"- `openai`: The OpenAI configuration to use.\n- `moderation`: The moderation request to send.","ref":"OpenaiEx.Moderation.html#create/2-arguments"},{"type":"function","title":"Returns - OpenaiEx.Moderation.create/2","doc":"A map containing the fields of the moderation response.","ref":"OpenaiEx.Moderation.html#create/2-returns"},{"type":"function","title":"OpenaiEx.Moderation.new/1","doc":"Creates a new moderation request with the given arguments.","ref":"OpenaiEx.Moderation.html#new/1"},{"type":"function","title":"Arguments - OpenaiEx.Moderation.new/1","doc":"- `args`: A list of key-value pairs, or a map, representing the fields of the moderation request.","ref":"OpenaiEx.Moderation.html#new/1-arguments"},{"type":"function","title":"Returns - OpenaiEx.Moderation.new/1","doc":"A map containing the fields of the moderation request.\n\nThe `:input` field is required.\n\nExample usage:\n\n    iex> OpenaiEx.Moderation.new(input: \"This is a test\")\n    %{\n      input: \"This is a test\"\n    }\n\n    iex> OpenaiEx.Moderation.new(%{input: \"This is a test\"})\n    %{\n      input: \"This is a test\"\n    }","ref":"OpenaiEx.Moderation.html#new/1-returns"},{"type":"extras","title":"OpenaiEx User Guide","doc":"# OpenaiEx User Guide\n\n```elixir\nMix.install([\n  #  {:openai_ex, git: \"https://github.com/restlessronin/openai_ex.git\", tag: \"v0.2.3\"},\n  {:openai_ex, \"~> 0.2.3\"},\n  #  {:openai_ex, path: Path.join(__DIR__, \"..\")},\n  {:kino, \"~> 0.10.0\"}\n])\n```","ref":"userguide.html"},{"type":"extras","title":"Introduction - OpenaiEx User Guide","doc":"`OpenaiEx` is an Elixir library that provides a community-maintained OpenAI API client especially for Livebook development.\n\nAt this point, all current API endpoints and features are supported, including the **streaming version of the completion and chat completion endpoints**.\n\nThere are some differences compared to other elixir openai wrappers.\n\n* I tried to faithfully mirror the naming/structure of the official python api. For example, content that is already in memory can be uploaded as part of a request, it doesn't have to be read from a file at a local path.\n* I was developing for a livebook use-case, so I don't have any config, only environment variables.\n* Streaming API versions are fully supported.\n\nTo learn how to use OpenaiEx, you can refer to the relevant parts of the official OpenAI API reference documentation, which we link to throughout this document.\n\nThis file is an executable Livebook, which means you can interactively run and modify the code samples provided. We encourage you to open it in Livebook and try out the code for yourself!","ref":"userguide.html#introduction"},{"type":"extras","title":"Installation - OpenaiEx User Guide","doc":"You can install OpenaiEx using Mix:\n\n#","ref":"userguide.html#installation"},{"type":"extras","title":"In Livebook - OpenaiEx User Guide","doc":"Add the following code to the first connection cell:\n\n \n\n```elixir\nMix.install(\n  [\n    {:openai_ex, \"~> 0.2.3\"}\n  ],\n)\n```\n\n#","ref":"userguide.html#in-livebook"},{"type":"extras","title":"In a Mix Project - OpenaiEx User Guide","doc":"Add the following to your mix.exs file:\n\n \n\n```elixir\ndef deps do\n  [\n    {:openai_ex, \"~> 0.2.3\"}\n  ]\nend\n```","ref":"userguide.html#in-a-mix-project"},{"type":"extras","title":"Authentication - OpenaiEx User Guide","doc":"To authenticate with the OpenAI API, you will need an API key. We recommend storing your API key in an environment variable. Since we are using Livebook, we can store this and other environment variables as [Livebook Hub Secrets](https://news.livebook.dev/hubs-and-secret-management---launch-week-1---day-3-3tMaJ2).\n\n```elixir\napikey = System.fetch_env!(\"LB_OPENAI_API_KEY\")\nopenai = OpenaiEx.new(apikey)\n```\n\nYou can also specify an organization if you are a member of more than one:\n\n```elixir\n# organization = System.fetch_env!(\"LB_OPENAI_ORGANIZATION\")\n# openai = OpenaiEx.new(apikey, organization)\n```\n\nFor more information on authentication, see the [OpenAI API Authentication reference](https://platform.openai.com/docs/api-reference/authentication).","ref":"userguide.html#authentication"},{"type":"extras","title":"Model - OpenaiEx User Guide","doc":"#","ref":"userguide.html#model"},{"type":"extras","title":"List Models - OpenaiEx User Guide","doc":"To list all available models, use the [`Model.list()`](https://platform.openai.com/docs/api-reference/models/list) function:\n\n```elixir\nalias OpenaiEx.Model\n\nopenai |> Model.list()\n```\n\n#","ref":"userguide.html#list-models"},{"type":"extras","title":"Retrieve Models - OpenaiEx User Guide","doc":"To retrieve information about a specific model, use the [`Model.retrieve()`](https://platform.openai.com/docs/api-reference/models/retrieve) function:\n\n```elixir\nopenai |> Model.retrieve(\"text-davinci-003\")\n```\n\nFor more information on using models, see the [OpenAI API Models reference](https://platform.openai.com/docs/api-reference/models).","ref":"userguide.html#retrieve-models"},{"type":"extras","title":"Completion - OpenaiEx User Guide","doc":"To generate a completion, you first need to define a completion request structure using the `Completion.new()` function. This function takes several parameters, such as the model ID, the prompt, the maximum number of tokens, etc.\n\n```elixir\nalias OpenaiEx.Completion\n\ncompletion_req =\n  Completion.new(\n    model: \"text-davinci-003\",\n    prompt:\n      \"Give me some background on the elixir language. Why was it created? What is it used for? What distinguishes it from other languages? How popular is it?\",\n    max_tokens: 500,\n    temperature: 0\n  )\n```\n\nOnce you have defined the completion request structure, you can generate a completion using the [`Completion.create()`](https://platform.openai.com/docs/api-reference/completions/create) function:\n\n```elixir\ncomp_response = openai |> Completion.create(completion_req)\n```\n\nYou can also call the endpoint and have it return a stream. This returns the result as a series of tokens, which have to be put together in code.\n\nTo use the stream option, call the `Completion.create()` function with `stream: true`\n\n```elixir\ncompletion_stream = openai |> Completion.create(completion_req, stream: true)\n\ncompletion_stream |> Stream.flat_map(& &1) |> Enum.each(fn x -> IO.puts(inspect(x)) end)\n```\n\nFor an example of how to programmatically work with this stream, check out the [Completions Bot livebook](https://hexdocs.pm/openai_ex/completions.html) which builds a ChatBot UI using the Completion API (with and without streaming).\n\nFor more information on generating completions, see the [OpenAI API Completions reference](https://platform.openai.com/docs/api-reference/completions).","ref":"userguide.html#completion"},{"type":"extras","title":"Chat Completion - OpenaiEx User Guide","doc":"To generate a chat completion, you need to define a chat completion request structure using the `ChatCompletion.new()` function. This function takes several parameters, such as the model ID and a list of chat messages. We have a module `ChatMessage` which helps create messages in the [chat format](https://platform.openai.com/docs/guides/chat/introduction).\n\n```elixir\nalias OpenaiEx.ChatCompletion\nalias OpenaiEx.ChatMessage\n\nchat_req =\n  ChatCompletion.new(\n    model: \"gpt-3.5-turbo\",\n    messages: [\n      ChatMessage.user(\n        \"Give me some background on the elixir language. Why was it created? What is it used for? What distinguishes it from other languages? How popular is it?\"\n      )\n    ]\n  )\n```\n\nYou can generate a chat completion using the [`ChatCompletion.create()`](https://platform.openai.com/docs/api-reference/chat/completions/create) function:\n\n```elixir\nchat_response = openai |> ChatCompletion.create(chat_req)\n```\n\nYou can also call the endpoint and have it stream the response. This returns the result as a series of tokens, which have to be put together in code.\n\nTo use the stream option, call the `ChatCompletion.create()` function with `stream: true`\n\n```elixir\nchat_stream = openai |> ChatCompletion.create(chat_req, stream: true)\n\nchat_stream |> Stream.flat_map(& &1) |> Enum.each(fn x -> IO.puts(inspect(x)) end)\n```\n\nFor a more in-depth example of `ChatCompletion`, check out the [Deeplearning.AI OrderBot Livebook](https://hexdocs.pm/openai_ex/dlai_orderbot.html).\n\nFor a detailed example of the use of the streaming `ChatCompletion` API, check out [Streaming Orderbot](https://hexdocs.pm/openai_ex/streaming_orderbot.html), the streaming equivalent of the prior example.\n\nFor more information on generating chat completions, see the [OpenAI API Chat Completions reference](https://platform.openai.com/docs/api-reference/chat).","ref":"userguide.html#chat-completion"},{"type":"extras","title":"Edit - OpenaiEx User Guide","doc":"First you need to define an edit request structure using the `Edit.new()` function. This function takes several parameters, such as the model ID, an input and an instruction.\n\n```elixir\nalias OpenaiEx.Edit\n\nedit_req =\n  Edit.new(\n    model: \"text-davinci-edit-001\",\n    input: \"What day of the wek is it?\",\n    instruction: \"Fix the spelling mistakes\"\n  )\n```\n\nTo generate the edit, call the [`Edit.create()`](https://platform.openai.com/docs/api-reference/edits) function.\n\n```elixir\nedit_response = openai |> Edit.create(edit_req)\n```\n\nFor more information on generating edits, see the [OpenAI API Edit reference](https://platform.openai.com/docs/api-reference/edits).","ref":"userguide.html#edit"},{"type":"extras","title":"Image - OpenaiEx User Guide","doc":"#","ref":"userguide.html#image"},{"type":"extras","title":"Generate Image - OpenaiEx User Guide","doc":"We define the image creation request structure using the `Image.new` function\n\n```elixir\nalias OpenaiEx.Image\n\nimg_req = Image.new(prompt: \"A cute baby sea otter\", size: \"256x256\", n: 2)\n```\n\nThen call the [`Image.create()`](https://platform.openai.com/docs/api-reference/images/create) function to generate the images.\n\n```elixir\nimg_response = openai |> Image.create(img_req)\n```\n\nFor more information on generating images, see the [OpenAI API Image reference](https://platform.openai.com/docs/api-reference/images).\n\n##","ref":"userguide.html#generate-image"},{"type":"extras","title":"Fetch the generated images - OpenaiEx User Guide","doc":"With the information in the image response, we can fetch the images from their URLs\n\n```elixir\nfetch_blob = fn url ->\n  Finch.build(:get, url) |> Finch.request!(OpenaiEx.Finch) |> Map.get(:body)\nend\n```\n\n```elixir\nfetched_images = img_response[\"data\"] |> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() end)\n```\n\n##","ref":"userguide.html#fetch-the-generated-images"},{"type":"extras","title":"View the generated images - OpenaiEx User Guide","doc":"Finally, we can render the images using Kino\n\n```elixir\nfetched_images\n|> Enum.map(fn r -> r |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\n```elixir\nimg_to_expmt = fetched_images |> List.first()\n```\n\n#","ref":"userguide.html#view-the-generated-images"},{"type":"extras","title":"Edit Image - OpenaiEx User Guide","doc":"We define an image edit request structure using the `Image.Edit.new()` function. This function requires an image and a mask. For the image, we will use the one that we received. Let's load the mask from a URL.\n\n```elixir\nstar_mask =\n  fetch_blob.(\n    \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/images/starmask.png\"\n  )\n\n# star_mask = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/images/starmask.png\"))\n```\n\nSet up the image edit request with image, mask and prompt.\n\n```elixir\nimg_edit_req =\n  Image.Edit.new(\n    image: img_to_expmt,\n    mask: star_mask,\n    size: \"256x256\",\n    prompt: \"Image shows a smiling Otter\"\n  )\n```\n\nWe then call the [`Image.create_edit()`]() function\n\n```elixir\nimg_edit_response = openai |> Image.create_edit(img_edit_req)\n```\n\nand view the result\n\n```elixir\nimg_edit_response[\"data\"]\n|> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\n#","ref":"userguide.html#edit-image"},{"type":"extras","title":"Image Variations - OpenaiEx User Guide","doc":"We define an image variation request structure using the `Image.Variation.new()` function. This function requires an image.\n\n```elixir\nimg_var_req = Image.Variation.new(image: img_to_expmt, size: \"256x256\")\n```\n\nThen call the [`Image.create_variation()`](https://platform.openai.com/docs/api-reference/images/create-variation) function to generate the images.\n\n \n\n###\n\n```elixir\nimg_var_response = openai |> Image.create_variation(img_var_req)\n```\n\n```elixir\nimg_var_response[\"data\"]\n|> Enum.map(fn i -> i[\"url\"] |> fetch_blob.() |> Kino.Image.new(\"image/png\") |> Kino.render() end)\n```\n\nFor more information on images variations, see the [OpenAI API Image Variations reference](https://platform.openai.com/docs/api-reference/images/create-variation).","ref":"userguide.html#image-variations"},{"type":"extras","title":"Embedding - OpenaiEx User Guide","doc":"Define the embedding request structure using `Embedding.new`.\n\n```elixir\nalias OpenaiEx.Embedding\n\nemb_req =\n  Embedding.new(\n    model: \"text-embedding-ada-002\",\n    input: \"The food was delicious and the waiter...\"\n  )\n```\n\nThen call the [`Embedding.create()`]() function.\n\n```elixir\nemb_response = openai |> Embedding.create(emb_req)\n```\n\nFor more information on generating embeddings, see the [OpenAI API Embedding reference](https://platform.openai.com/docs/api-reference/embeddings/create)","ref":"userguide.html#embedding"},{"type":"extras","title":"Audio - OpenaiEx User Guide","doc":"#","ref":"userguide.html#audio"},{"type":"extras","title":"Transcription - OpenaiEx User Guide","doc":"To define an Audio request structure, we need to create a file parameter using `Audio.File.new()`.\n\n```elixir\nalias OpenaiEx.Audio\n\naudio_url = \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/transcribe.mp3\"\n\naudio_file = OpenaiEx.new_file(name: audio_url, content: fetch_blob.(audio_url))\n\n# audio_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/transcribe.mp3\"))\n```\n\nThe file parameter is used to create the Audio request structure\n\n```elixir\naudio_req = Audio.new(file: audio_file, model: \"whisper-1\")\n```\n\nWe then call the [`Audio.transcribe()`](https://platform.openai.com/docs/api-reference/audio/create) function to create a transcription.\n\n```elixir\naudio_response = openai |> Audio.transcribe(audio_req)\n```\n\n#","ref":"userguide.html#transcription"},{"type":"extras","title":"Translation - OpenaiEx User Guide","doc":"The translation call uses practically the same request structure, but calls the `Audio.translate()` endpoint\n\nFor more information on the audio endpoints see the [Openai API Audio Reference](https://platform.openai.com/docs/api-reference/audio)","ref":"userguide.html#translation"},{"type":"extras","title":"File - OpenaiEx User Guide","doc":"#","ref":"userguide.html#file"},{"type":"extras","title":"List files - OpenaiEx User Guide","doc":"To request all files that belong to the user organization, call the [`File.list()`](https://platform.openai.com/docs/api-reference/files/list) function\n\n```elixir\nalias OpenaiEx.File\n\nopenai |> File.list()\n```\n\n#","ref":"userguide.html#list-files"},{"type":"extras","title":"Upload files - OpenaiEx User Guide","doc":"To upload a file, we need to create a file parameter, and then the upload request\n\n```elixir\n# fine_tune_file = OpenaiEx.new_file(path: Path.join(__DIR__, \"../assets/fine-tune.jsonl\"))\nftf_url = \"https://raw.githubusercontent.com/restlessronin/openai_ex/main/assets/fine-tune.jsonl\"\n\nfine_tune_file = OpenaiEx.new_file(name: ftf_url, content: fetch_blob.(ftf_url))\nupload_req = File.new_upload(file: fine_tune_file, purpose: \"fine-tune\")\n```\n\nThen we call the [`File.create()`](https://platform.openai.com/docs/api-reference/files/upload) function to upload the file\n\n```elixir\nupload_res = openai |> File.create(upload_req)\n```\n\nWe can verify that the file has been uploaded by calling\n\n```elixir\nopenai |> File.list()\n```\n\nWe grab the file id from the previous response value to use in the following samples\n\n```elixir\nfile_id = upload_res[\"id\"]\n```\n\n#","ref":"userguide.html#upload-files"},{"type":"extras","title":"Retrieve files - OpenaiEx User Guide","doc":"In order to retrieve meta information on a file, we simply call the [`File.retrieve()`]() function with the given id\n\n```elixir\nopenai |> File.retrieve(file_id)\n```\n\n#","ref":"userguide.html#retrieve-files"},{"type":"extras","title":"Retrieve file content - OpenaiEx User Guide","doc":"Similarly to download the file contents, we call [`File.download()`]()\n\n```elixir\nopenai |> File.download(file_id)\n```\n\n#","ref":"userguide.html#retrieve-file-content"},{"type":"extras","title":"Delete file - OpenaiEx User Guide","doc":"Finally, we can delete the file by calling [`File.delete()`](https://platform.openai.com/docs/api-reference/files/delete)\n\n```elixir\nopenai |> File.delete(file_id)\n```\n\nVerify that the file has been deleted by listing files again\n\n```elixir\nopenai |> File.list()\n```","ref":"userguide.html#delete-file"},{"type":"extras","title":"FineTune - OpenaiEx User Guide","doc":"To run a fine-tune, we minimally need a training file. We will re-run the file creation request above.\n\n```elixir\nupload_res = openai |> File.create(upload_req)\n```\n\nNext we call `FineTune.new()` to create a new request structure\n\n```elixir\nalias OpenaiEx.FineTune\n\nft_req = FineTune.new(training_file: upload_res[\"id\"])\n```\n\nTo begin the fine tune, we call the [`FineTune.create()`](https://platform.openai.com/docs/api-reference/fine-tunes/create) function\n\n```elixir\nft_res = openai |> FineTune.create(ft_req)\n```\n\nWe can list all fine tunes by calling [`FineTune.list()`](https://platform.openai.com/docs/api-reference/fine-tunes/list)\n\n```elixir\nopenai |> FineTune.list()\n```\n\nThe function [`FineTune.retrieve()`](https://platform.openai.com/docs/api-reference/fine-tunes/retrieve) gets the details of a particular fine tune.\n\n```elixir\nft_id = ft_res[\"id\"]\nopenai |> FineTune.retrieve(fine_tune_id: ft_id)\n```\n\nand [`FineTune.list_events()`](https://platform.openai.com/docs/api-reference/fine-tunes/events) can be called to get the events\n\n```elixir\nopenai |> FineTune.list_events(fine_tune_id: ft_id)\n```\n\nTo cancel a Fine Tune job, call [`FineTune.cancel()`](https://platform.openai.com/docs/api-reference/fine-tunes/cancel)\n\n```elixir\nopenai |> FineTune.cancel(fine_tune_id: ft_id)\n```\n\nA fine tuned model can be deleted by calling the [`Model.delete()`](https://platform.openai.com/docs/api-reference/fine-tunes/delete-model)\n\n```elixir\nft_model = ft_res[\"fine_tuned_model\"]\n\nunless is_nil(ft_model) do\n  openai |> Model.delete(ft_model)\nend\n```\n\nFor more information on the fine tune endpoints see the [Openai API Moderation Reference](https://platform.openai.com/docs/api-reference/fine-tunes)","ref":"userguide.html#finetune"},{"type":"extras","title":"Moderation - OpenaiEx User Guide","doc":"We use the moderation API by calling `Moderation.new()` to create a new request\n\n```elixir\nalias OpenaiEx.Moderation\n\nmod_req = Moderation.new(input: \"I want to kill people\")\n```\n\nThe call the function [`Moderation.create()`](https://platform.openai.com/docs/api-reference/moderations/create)\n\n```elixir\nmod_res = openai |> Moderation.create(mod_req)\n```\n\nFor more information on the moderation endpoints see the [Openai API Moderation Reference](https://platform.openai.com/docs/api-reference/moderations)","ref":"userguide.html#moderation"},{"type":"extras","title":"Streaming Orderbot","doc":"# Streaming Orderbot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.2.3\"},\n  {:kino, \"~> 0.10.0\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.ChatCompletion\nalias OpenaiEx.ChatMessage\n```","ref":"streaming_orderbot.html"},{"type":"extras","title":"Setup - Streaming Orderbot","doc":"This notebook creates an Orderbot, similar to the one in [Deeplearning.AI Orderbot](https://hexdocs.pm/openai_ex/0.2.3/dlai_orderbot.html), but using the streaming version of the Chat Completion API.\n\n```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\n```elixir\ndefmodule OpenaiEx.Notebooks.StreamingOrderbot do\n  alias OpenaiEx\n  alias OpenaiEx.ChatCompletion\n\n  def create_chat_req(args = [_ | _]) do\n    args\n    |> Enum.into(%{\n      model: \"gpt-3.5-turbo\",\n      temperature: 0\n    })\n    |> ChatCompletion.new()\n  end\n\n  def get_completion_stream(openai = %OpenaiEx{}, cc_req = %{}) do\n    openai\n    |> ChatCompletion.create(cc_req, stream: true)\n    |> Stream.flat_map(& &1)\n    |> Stream.map(fn %{data: d} -> d |> Map.get(\"choices\") |> Enum.at(0) |> Map.get(\"delta\") end)\n    |> Stream.filter(fn map -> map |> Map.has_key?(\"content\") end)\n    |> Stream.map(fn map -> map |> Map.get(\"content\") end)\n  end\n\n  def stream_completion_to_frame(openai = %OpenaiEx{}, messages, frame) do\n    openai\n    |> get_completion_stream(create_chat_req(messages: messages))\n    |> Enum.reduce(\"\", fn token, text ->\n      next = text   token\n      Kino.Frame.render(frame, Kino.Text.new(next))\n      next\n    end)\n  end\n\n  def create_orderbot(openai = %OpenaiEx{}, context) do\n    chat_frame = Kino.Frame.new()\n    last_frame = Kino.Frame.new()\n    inputs = [prompt: Kino.Input.textarea(\"You\")]\n    form = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\n    Kino.Frame.render(chat_frame, Kino.Markdown.new(\"#","ref":"streaming_orderbot.html#setup"},{"type":"extras","title":"Orderbot Chat\")) - Streaming Orderbot","doc":"Kino.Layout.grid([chat_frame, last_frame, form], boxed: true, gap: 16) |> Kino.render()\n\n    bot_says = openai |> stream_completion_to_frame(context, last_frame)\n\n    Kino.listen(\n      form,\n      context ++ [ChatMessage.assistant(bot_says)],\n      fn %{data: %{prompt: you_say}}, history ->\n        Kino.Frame.render(last_frame, Kino.Text.new(\"\"))\n        Kino.Frame.append(chat_frame, Kino.Text.new(List.last(history).content))\n        Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**You** #{you_say}\"))\n\n        bot_says =\n          openai |> stream_completion_to_frame(history ++ [ChatMessage.user(you_say)], last_frame)\n\n        {:cont, history ++ [ChatMessage.user(you_say), ChatMessage.assistant(bot_says)]}\n      end\n    )\n  end\nend\n\nalias OpenaiEx.Notebooks.StreamingOrderbot\n```","ref":"streaming_orderbot.html#orderbot-chat"},{"type":"extras","title":"Orderbot - Streaming Orderbot","doc":"```elixir\ncontext = [\n  ChatMessage.system(\"\"\"\n  You are OrderBot, an automated service to collect orders for a pizza restaurant. \\\n  You first greet the customer, then collects the order, \\\n  and then asks if it's a pickup or delivery. \\\n  You wait to collect the entire order, then summarize it and check for a final \\\n  time if the customer wants to add anything else. \\\n  If it's a delivery, you ask for an address. \\\n  Finally you collect the payment.\\\n  Make sure to clarify all options, extras and sizes to uniquely \\\n  identify the item from the menu.\\\n  You respond in a short, very conversational friendly style. \\\n  The menu includes \\\n  pepperoni pizza  12.95, 10.00, 7.00 \\\n  cheese pizza   10.95, 9.25, 6.50 \\\n  eggplant pizza   11.95, 9.75, 6.75 \\\n  fries 4.50, 3.50 \\\n  greek salad 7.25 \\\n  Toppings: \\\n  extra cheese 2.00, \\\n  mushrooms 1.50 \\\n  sausage 3.00 \\\n  canadian bacon 3.50 \\\n  AI sauce 1.50 \\\n  peppers 1.00 \\\n  Drinks: \\\n  coke 3.00, 2.00, 1.00 \\\n  sprite 3.00, 2.00, 1.00 \\\n  bottled water 5.00 \\\n  \"\"\")\n]\n```\n\n```elixir\nopenai |> StreamingOrderbot.create_orderbot(context)\n```","ref":"streaming_orderbot.html#orderbot"},{"type":"extras","title":"Deeplearning.AI Order Bot","doc":"# Deeplearning.AI Order Bot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.2.3\"},\n  {:kino, \"~> 0.10.0\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.ChatCompletion\nalias OpenaiEx.ChatMessage\n```","ref":"dlai_orderbot.html"},{"type":"extras","title":"Source - Deeplearning.AI Order Bot","doc":"This notebook is an elixir translation of the python notebook in [Lesson 8](https://learn.deeplearning.ai/chatgpt-prompt-eng/lesson/8/chatbot), of [Deeplearning.AI](https://www.deeplearning.ai/)'s course [ChatGPT Prompt Engineering for Developers](https://www.deeplearning.ai/short-courses/chatgpt-prompt-engineering-for-developers/).","ref":"dlai_orderbot.html#source"},{"type":"extras","title":"Chat Format - Deeplearning.AI Order Bot","doc":"In this notebook, you will explore how you can utilize the chat format to have extended conversations with chatbots personalized or specialized for specific tasks or behaviors.\n\n#","ref":"dlai_orderbot.html#chat-format"},{"type":"extras","title":"Setup - Deeplearning.AI Order Bot","doc":"```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\n```elixir\ndefmodule OpenaiEx.Notebooks.DlaiOrderbot do\n  alias OpenaiEx\n  alias OpenaiEx.ChatCompletion\n\n  def create_chat_req(args = [_ | _]) do\n    args\n    |> Enum.into(%{\n      model: \"gpt-3.5-turbo\",\n      temperature: 0\n    })\n    |> ChatCompletion.new()\n  end\n\n  def get_completion(openai = %OpenaiEx{}, cc_req = %{}) do\n    openai\n    |> ChatCompletion.create(cc_req)\n    # for debugging\n    #    |> IO.inspect()\n    |> Map.get(\"choices\")\n    |> Enum.at(0)\n    |> Map.get(\"message\")\n    |> Map.get(\"content\")\n  end\nend\n\nalias OpenaiEx.Notebooks.DlaiOrderbot\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are an assistant that speaks like Shakespeare.\"),\n  ChatMessage.user(\"tell me a joke\"),\n  ChatMessage.assistant(\"Why did the chicken cross the road\"),\n  ChatMessage.user(\"I don't know\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Hi, my name is Isa\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Yes, can you remind me, What is my name?\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```\n\n```elixir\nmessages = [\n  ChatMessage.system(\"You are friendly chatbot.\"),\n  ChatMessage.user(\"Hi, my name is Isa\"),\n  ChatMessage.assistant(\n    \"Hi Isa! It's nice to meet you. Is there anything I can help you with today?\"\n  ),\n  ChatMessage.user(\"Yes, can you remind me, What is my name?\")\n]\n\nreq = DlaiOrderbot.create_chat_req(messages: messages, temperature: 1)\nopenai |> DlaiOrderbot.get_completion(req)\n```","ref":"dlai_orderbot.html#setup"},{"type":"extras","title":"Order Bot - Deeplearning.AI Order Bot","doc":"We can automate the collection of user prompts and assistant responses to build a OrderBot. The OrderBot will take orders at a pizza restaurant.\n\n```elixir\ncontext = [\n  ChatMessage.system(\"\"\"\n  You are OrderBot, an automated service to collect orders for a pizza restaurant. \\\n  You first greet the customer, then collects the order, \\\n  and then asks if it's a pickup or delivery. \\\n  You wait to collect the entire order, then summarize it and check for a final \\\n  time if the customer wants to add anything else. \\\n  If it's a delivery, you ask for an address. \\\n  Finally you collect the payment.\\\n  Make sure to clarify all options, extras and sizes to uniquely \\\n  identify the item from the menu.\\\n  You respond in a short, very conversational friendly style. \\\n  The menu includes \\\n  pepperoni pizza  12.95, 10.00, 7.00 \\\n  cheese pizza   10.95, 9.25, 6.50 \\\n  eggplant pizza   11.95, 9.75, 6.75 \\\n  fries 4.50, 3.50 \\\n  greek salad 7.25 \\\n  Toppings: \\\n  extra cheese 2.00, \\\n  mushrooms 1.50 \\\n  sausage 3.00 \\\n  canadian bacon 3.50 \\\n  AI sauce 1.50 \\\n  peppers 1.00 \\\n  Drinks: \\\n  coke 3.00, 2.00, 1.00 \\\n  sprite 3.00, 2.00, 1.00 \\\n  bottled water 5.00 \\\n  \"\"\")\n]\n```\n\n```elixir\nappend_completion = fn openai, messages, frame ->\n  req = DlaiOrderbot.create_chat_req(messages: messages)\n  bot_says = openai |> DlaiOrderbot.get_completion(req)\n  Kino.Frame.append(frame, Kino.Text.new(\"#{bot_says}\"))\n  bot_says\nend\n\nchat_frame = Kino.Frame.new()\ninputs = [prompt: Kino.Input.textarea(\"You\")]\nform = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\nKino.Frame.render(chat_frame, Kino.Markdown.new(\"#","ref":"dlai_orderbot.html#order-bot"},{"type":"extras","title":"Orderbot Chat\")) - Deeplearning.AI Order Bot","doc":"Kino.Layout.grid([chat_frame, form], boxed: true, gap: 16) |> Kino.render()\n\nbot_says = openai |> append_completion.(context, chat_frame)\n\nKino.listen(\n  form,\n  context ++ [ChatMessage.assistant(bot_says)],\n  fn %{data: %{prompt: you_say}}, history ->\n    Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**You** #{you_say}\"))\n\n    bot_says = openai |> append_completion.(history ++ [ChatMessage.user(you_say)], chat_frame)\n\n    {:cont, history ++ [ChatMessage.user(you_say), ChatMessage.assistant(bot_says)]}\n  end\n)\n```","ref":"dlai_orderbot.html#orderbot-chat"},{"type":"extras","title":"completions","doc":"# Completions Bot\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.2.3\"},\n  {:kino, \"~> 0.10.0\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.Completion\n```","ref":"completions.html"},{"type":"extras","title":"Model Choices - completions","doc":"```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\n```elixir\ncomp_models = [\n  \"text-davinci-003\",\n  \"text-davinci-002\",\n  \"text-curie-001\",\n  \"text-babbage-001\",\n  \"text-ada-001\"\n]\n```","ref":"completions.html#model-choices"},{"type":"extras","title":"Normal Completion - completions","doc":"This function calls the completion API and renders the result in the given Kino frame.\n\n```elixir\ncompletion = fn model, prompt, max_tokens, temperature, last_frame ->\n  text =\n    openai\n    |> Completion.create(%{\n      model: model,\n      prompt: prompt,\n      max_tokens: max_tokens,\n      temperature: temperature\n    })\n    |> Map.get(\"choices\")\n    |> Enum.at(0)\n    |> Map.get(\"text\")\n\n  Kino.Frame.render(last_frame, Kino.Markdown.new(\"**Bot** #{text}\"))\n  text\nend\n```","ref":"completions.html#normal-completion"},{"type":"extras","title":"Streaming Completion - completions","doc":"This function calls the streaming completion API and continously updates the Kino frame with the latest tokens\n\n```elixir\ncompletion_stream = fn model, prompt, max_tokens, temperature, last_frame ->\n  token_stream =\n    openai\n    |> Completion.create(\n      %{\n        model: model,\n        prompt: prompt,\n        max_tokens: max_tokens,\n        temperature: temperature\n      },\n      stream: true\n    )\n    |> Stream.flat_map(& &1)\n    |> Stream.map(fn %{data: data} ->\n      data |> Map.get(\"choices\") |> Enum.at(0) |> Map.get(\"text\")\n    end)\n\n  token_stream\n  |> Enum.reduce(\"\", fn out, acc ->\n    next = acc   out\n    Kino.Frame.render(last_frame, Kino.Markdown.new(\"**Bot** #{next}\"))\n    next\n  end)\nend\n```","ref":"completions.html#streaming-completion"},{"type":"extras","title":"Create a Form UI - completions","doc":"This is a function to create a Form UI that can be used to call the completion API. The 2nd parameter determines whether the normal or streaming API is called.\n\n```elixir\ncreate_form = fn title, completion_fn ->\n  chat_frame = Kino.Frame.new()\n  last_frame = Kino.Frame.new()\n\n  Kino.Frame.render(chat_frame, Kino.Markdown.new(title))\n\n  inputs = [\n    model: Kino.Input.select(\"Model\", comp_models |> Enum.map(fn x -> {x, x} end)),\n    max_tokens: Kino.Input.number(\"Max Tokens\", default: 400),\n    temperature: Kino.Input.number(\"Temperature\", default: 1),\n    prompt: Kino.Input.textarea(\"Prompt\")\n  ]\n\n  form = Kino.Control.form(inputs, submit: \"Send\", reset_on_submit: [:prompt])\n\n  Kino.listen(\n    form,\n    fn %{\n         data: %{\n           prompt: prompt,\n           model: model,\n           max_tokens: max_tokens,\n           temperature: temperature\n         }\n       } ->\n      Kino.Frame.render(chat_frame, Kino.Markdown.new(title))\n      Kino.Frame.append(chat_frame, Kino.Markdown.new(\"**Me** #{prompt}\"))\n\n      completion_fn.(model, prompt, max_tokens, temperature, last_frame)\n    end\n  )\n\n  Kino.Layout.grid([chat_frame, last_frame, form], boxed: true, gap: 16)\nend\n```\n\n#","ref":"completions.html#create-a-form-ui"},{"type":"extras","title":"Normal Chatbot - completions","doc":"Create the Form for the non-streaming completion API and use it.\n\n```elixir\ncreate_form.(\"","ref":"completions.html#normal-chatbot"},{"type":"extras","title":"Completion Chatbot\", completion) - completions","doc":"```\n\n#","ref":"completions.html#completion-chatbot-completion"},{"type":"extras","title":"Streaming Chatbot - completions","doc":"Create the form for the streaming completion API, and use it.\n\n```elixir\ncreate_form.(\"","ref":"completions.html#streaming-chatbot"},{"type":"extras","title":"Streaming Chatbot\", completion_stream) - completions","doc":"```","ref":"completions.html#streaming-chatbot-completion_stream"},{"type":"extras","title":"images","doc":"# Image Generation Kino App\n\n```elixir\nMix.install([\n  {:openai_ex, \"~> 0.2.3\"},\n  {:kino, \"~> 0.9.2\"}\n])\n\nalias OpenaiEx\nalias OpenaiEx.Image\n```","ref":"images.html"},{"type":"extras","title":"Simple Kino UI - images","doc":"```elixir\nopenai = System.fetch_env!(\"LB_OPENAI_API_KEY\") |> OpenaiEx.new()\n```\n\nset default parameters for image generation, and define a function to fetch generated images from a URL.\n\n```elixir\nsize = \"256x256\"\nn = 4\n\nfetch_blob = fn url ->\n  Finch.build(:get, url) |> Finch.request!(OpenaiEx.Finch) |> Map.get(:body)\nend\n```\n\n#","ref":"images.html#simple-kino-ui"},{"type":"extras","title":"Prompt / Response UI - images","doc":"```elixir\ntext_input = Kino.Input.textarea(\"Describe Image\")\n\nform = Kino.Control.form([text: text_input], submit: \"Generate\")\nframe = Kino.Frame.new()\n\nKino.listen(form, fn %{data: %{text: prompt}} ->\n  Kino.Frame.render(frame, Kino.Text.new(\"Running...\"))\n\n  res_urls =\n    openai\n    |> Image.create(%{\n      prompt: prompt,\n      n: n,\n      size: size\n    })\n    #   |> IO.inspect()\n    |> Map.get(\"data\")\n    |> Enum.map(fn x -> x[\"url\"] end)\n\n  res_urls\n  |> Enum.map(fn x -> x |> fetch_blob.() |> Kino.Image.new(\"image/png\") end)\n  |> Kino.Layout.grid(columns: 2)\n  |> then(&Kino.Frame.render(frame, &1))\nend)\n\nKino.Layout.grid([form, frame], boxed: true, gap: 16)\n```","ref":"images.html#prompt-response-ui"}],"content_type":"text/markdown"}